echo off
rem ASM2LIB lib [asm]
rem     lib - filename of library
rem         1) extension must be "LIB"
rem         2) extension must not be specified
rem     asm - filename of Assembly source/object file (optional)
rem         1) extension must not be specified
rem         2) Source file must exist for operation #2
rem         3) Object file should be in library for operation #3
rem
echo                        Assembler Library Manager
echo  
if .%1 == . goto nolib
echo      0) Create library file
echo      1) Review existing library file
echo      2) Assemble and add procedure to library
echo      3) Delete entry from library
:again
query Select number of operation:
echo  
if errorlevel 4 goto error
if errorlevel 3 goto delete
if errorlevel 2 goto add
if errorlevel 1 goto review
rem CREATE
if not exist %1.lib goto cr1
query LIB file exists.  Do you want to replace (Y/N)?
if not errorlevel 1 goto endall
ren %1.lib %1.bak
:cr1
libsetup
lib %1
echo %1 Library created
goto endall
:REVIEW
if not exist %1.lib goto nolib
lib %1,review.lst
more<review.lst
goto endall
:ADD
if not exist %1.lib goto nolib
if .%2 == . goto nosource
if exist %2 goto bad-ext
if not exist %2.asm goto nofile
masm %2 %2 %2 nul
echo  Ctrl-C to stop if errors 
pause
lib %1 -%2+%2;
erase %2.obj
echo  %2 Module added to library: %1
goto endall
:nosource
echo  No source file specified...
goto endall
:bad-ext
echo  ASM must NOT be specified
goto endall
:nofile
echo  Source file does not exist
goto endall
:DELETE
query Are you sure?
if errorlevel 1 goto del1
goto endall
:del1
if not exist %1.lib goto nolib
if .%2 == . goto nodel
lib %1 -%2;
echo %2 Deleted from library: %1
goto endall
:nodel
echo  No entry specified for deletion
goto endall
:error
echo  Invalid response (use digits 0-3)
goto again
:nolib
echo  Library file does not exist or not specified
:endall
